/*
*   select:
*    00  32-bit word
*    01  8-bit byte
*    10  16-bit half-word
*/  
module mcombine(output reg [31:0] mout, input [31:0] db,
	output reg [3:0] bytenable, input [1:0] select, input [1:0] addr);

always
	case (select)
	2'b01: 
		case (addr)
		2'b00: begin
				bytenable <= 4'h1;
				mout <= db;
				end
		2'b01: begin
				bytenable <= 4'h2;
				mout <= {16'h0000,db[7:0],8'h00};
				end
		2'b10: begin
				bytenable <= 4'h4;
				mout <= {8'h00,db[7:0],16'h0000};
				end
		2'b11: begin
				bytenable <= 4'h8;
				mout <= {db[7:0],24'h000000};
				end
		endcase
	2'b10:
		if (addr[1]) 
			begin
			bytenable <= 4'hc;
			mout <= {db[15:0],16'h0000};
			end
		else
			begin
			bytenable <= 4'h3;
			mout <= db;
			end
	default: 
			begin
			bytenable <= 4'hf;
			mout <= db;
			end
	endcase
endmodule
